"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HomeDataRecord = void 0;
const db_1 = require("../utils/db/db");
class HomeDataRecord {
    constructor(obj) {
        this.user_id = obj.user_id;
        this.username = obj.username;
        this.points = obj.points;
    }
    static getAll() {
        return __awaiter(this, void 0, void 0, function* () {
            const [results] = (yield db_1.pool.execute("SELECT `play`.`user_id`, `user`.`username`, `play`.`points` FROM `play` JOIN `user` ON" +
                " `play`.`user_id` = `user`.`id`"));
            return results.length === 0 ? null : results.map((obj) => obj);
        });
    }
    static getNumberOfGames(user_id) {
        return __awaiter(this, void 0, void 0, function* () {
            const [results] = (yield db_1.pool.execute("SELECT * FROM `play` WHERE `user_id` = :user_id", {
                user_id,
            }));
            return results.length;
        });
    }
}
exports.HomeDataRecord = HomeDataRecord;
//# sourceMappingURL=homeData.record.js.map