"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PlayRecord = void 0;
const handleErrors_1 = require("../utils/handleErrors");
const db_1 = require("../utils/db/db");
class PlayRecord {
    constructor(obj) {
        var _a;
        if (!obj.user_id || obj.user_id.length !== 36) {
            throw new handleErrors_1.ValidationError("The 'user id' should contain 36 characters.");
        }
        if (typeof obj.user_id !== "string") {
            throw new handleErrors_1.ValidationError("The 'user_id' data format is invalid!");
        }
        if (typeof obj.points !== "number") {
            throw new handleErrors_1.ValidationError("The 'points' data format must be number!");
        }
        this.user_id = obj.user_id;
        this.points = obj.points;
        this.date = (_a = obj.date) !== null && _a !== void 0 ? _a : new Date();
    }
    insert() {
        return __awaiter(this, void 0, void 0, function* () {
            yield db_1.pool.execute("INSERT INTO `play`(`user_id`,`points`, `date`)VALUES(:user_id,:points,:date)", this);
        });
    }
}
exports.PlayRecord = PlayRecord;
//# sourceMappingURL=play.record.js.map