"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.homeDataRouter = void 0;
const express_1 = require("express");
const homeData_record_1 = require("../records/homeData.record");
exports.homeDataRouter = (0, express_1.Router)();
exports.homeDataRouter.get("/data/:user_id", (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    const list = yield homeData_record_1.HomeDataRecord.getAll();
    const user = list.find((x) => x.user_id === req.params.user_id);
    const numOfGames = yield homeData_record_1.HomeDataRecord.getNumberOfGames(req.params.user_id);
    let sortedList = [];
    for (const obj of list) {
        const found = sortedList.find((x) => x.username === obj.username);
        found === undefined
            ? sortedList.push({
                username: obj.username,
                points: obj.points,
            })
            : (found.points += obj.points);
    }
    sortedList.sort((a, b) => {
        return b.points - a.points;
    });
    let id = 0;
    const scoreboard = sortedList.map((x) => {
        id++;
        return Object.assign(Object.assign({}, x), { id: id });
    });
    if (user === undefined || !user) {
        res.json({
            points: 0,
            number_of_games: 0,
            place: 0,
            scoreboard: scoreboard,
        });
    }
    else {
        const place = scoreboard.find((x) => x.username === user.username);
        res.json({
            points: place.points,
            number_of_games: numOfGames,
            place: place.id,
            scoreboard: scoreboard,
        });
    }
}));
//# sourceMappingURL=homeData.js.map